unit SudoSelecteur;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ComCtrls, ExtCtrls;

type
  TFrmSelecteur = class(TForm)
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheetPose: TTabSheet;
    TabSheetCandidats: TTabSheet;
    C1: TBitBtn;
    C2: TBitBtn;
    BtCancel: TBitBtn;
    C3: TBitBtn;
    C4: TBitBtn;
    C5: TBitBtn;
    C6: TBitBtn;
    C9: TBitBtn;
    C7: TBitBtn;
    C8: TBitBtn;
    P1: TBitBtn;
    P2: TBitBtn;
    P3: TBitBtn;
    P6: TBitBtn;
    P5: TBitBtn;
    P4: TBitBtn;
    P7: TBitBtn;
    P8: TBitBtn;
    P9: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
   Transparence : Integer;

   Procedure Couleur(Couleur : TColor; NumTag : Integer);
   procedure Button_OnOff(listeCandidats : String; NumTag : Integer);

  end;


implementation

{$R *.dfm}


// Dessine les textes des boutons avec la bonne couleur
procedure TFrmSelecteur.Couleur(Couleur : TColor; NumTag : Integer);
Var
 I : integer ;
begin
 For i := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TBitBtn then   // de type TBitBtn
   If (Components[i] as TBitBtn).Tag = NumTag then // avec le bon Tag (1 chiffer et 2 pour candidats)
   (Components[i] as TBitBtn).font.Color := Couleur;
end;

// Active ou Desactiver les boutons en fonction des candidats possibles
procedure TFrmSelecteur.Button_OnOff(listeCandidats : String; NumTag : Integer);
Var
 I : integer;
begin
 For I := 0 to ComponentCount-1 do   // pour chaque composant
  If Components[i] is TBitBtn then   // de type TBitBtn
   If (Components[i] as TBitBtn).Tag = NumTag then // avec le bon Tag (1 chiffer et 2 pour candidats)
    (Components[i] as TBitBtn).Enabled :=  Pos((Components[i] as TBitBtn).Caption,listeCandidats)> 0;
end;

// affiche le selecteur au bon endroit
procedure TFrmSelecteur.FormShow(Sender: TObject);
begin
 Left := mouse.CursorPos.X;
 Top  := mouse.CursorPos.Y;
 Transparence := 255;
end;


// si on joue au clavier

procedure TFrmSelecteur.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key in ['1'..'9'] then
 begin
  // si c'est la page candidat qui est active
  if PageControl1.ActivePageIndex = 0 then
  begin
   if key = '1' then begin P1.SetFocus ; P1.Click; end;
   if key = '2' then begin P2.SetFocus ; P2.Click; end;
   if key = '3' then begin P3.SetFocus ; P3.Click; end;
   if key = '4' then begin P4.SetFocus ; P4.Click; end;
   if key = '5' then begin P5.SetFocus ; P5.Click; end;
   if key = '6' then begin P6.SetFocus ; P6.Click; end;
   if key = '7' then begin P7.SetFocus ; P7.Click; end;
   if key = '8' then begin P8.SetFocus ; P8.Click; end;
   if key = '9' then begin P9.SetFocus ; P9.Click; end;
  end
  else
  begin
   if key = '1' then begin C1.SetFocus ; C1.Click; end;
   if key = '2' then begin C2.SetFocus ; c2.Click; end;
   if key = '3' then begin C3.SetFocus ; C3.Click; end;
   if key = '4' then begin C4.SetFocus ; C4.Click; end;
   if key = '5' then begin C5.SetFocus ; C5.Click; end;
   if key = '6' then begin C6.SetFocus ; C6.Click; end;
   if key = '7' then begin C7.SetFocus ; C7.Click; end;
   if key = '8' then begin C8.SetFocus ; C8.Click; end;
   if key = '9' then begin C9.SetFocus ; C9.Click; end;
  end;
 end;
end;

//gere la transparence
procedure TFrmSelecteur.FormMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
 Inc(Transparence,20);
 If Transparence > 255 then
  Transparence := 255;
 AlphaBlendValue := Transparence;
end;

//gere la transparence
procedure TFrmSelecteur.FormMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
 Dec(Transparence,20);
 If Transparence < 60 then
  Transparence := 60;
 AlphaBlendValue := Transparence;
end;

end.
