unit UAnalyse;

//*************************************************************
// Cette unit contient les methodes d'analyses et de recherches
//*************************************************************

interface

uses SysUtils,dialogs,math;

Const

 MaxDecouvertes = 255;  // prevoir large


type

 TCaseCourante = record
   Ligne     : ShortInt;
   Colonne   : ShortInt;
   Region    : ShortInt;
   Valeur    : String[1];
   LigReg    : ShortInt;  // ligne dans la region 1  3
   ColReg    : ShortInt;  // Colonne dans la region 1  3
   Cand      : String[9]; //chaine contenant les candidats restants
   Devoile   : ShortInt;
  end;

 TDecouverte  = record
   Ligne     : ShortInt;
   Colonne   : ShortInt;
   Candidat  : String[1];   // chaine contenant le candidat
   Operation : String[1];   // 'P' => Poser 'C' => enlever Candidat 'V' =>Voir
   Famille   : ShortInt;    // famille de l'analyses
   Groupe    : ShortInt;    // groupe de l'analyses si plusieurs decouvertes dans la m^me famille
   Vue       : String[1];   // 'O' = Vue 'N' = non vue dans la liste affiche
   Texte     : String[80];  // un peu de blabla
  end;



 Tableau  = array [1..9] of ShortInt;

 TableauReponse = Record
   Ligne    : Tableau;
   Colonne  : Tableau;
   Quantite : Tableau;
  end;

 TPosteUnite = Record
   Ligne    : ShortInt;
   Colonne  : ShortInt;
   Candidats: String[9];
  end;

  TGrille   = array[1..81] of TCaseCourante; // contient  grille actuelle
  TUnite    = array[1..9]  of TPosteUnite;   // contient un ligne , une colonne ou une region
  TOccCand  = array[1..9]  of ShortInt;      // petit tableau des occurences des candidats
  TListDec  = array[1..MaxDecouvertes] of TDecouverte; // tableau de decouvertes suite aux analyses





//******************  procedures principales d'analyses *********************/

procedure CandidatSeulDansCase(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
procedure CandidatPresentUneFois(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;TypeRecherche :String);
procedure JumeauxTriplesLignes(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
procedure JumeauxTriplesColonnes(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
procedure InterActionlignesRegion(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
procedure InterActionColonnesRegion(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
procedure ConfigurationsFranches(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;NbRecherche :ShortInt ;  TypeRecherche, chaine: String);
procedure DoubletsExlusifs(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille; TypeRecherche: String);
procedure TripletsExlusifs(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;TypeRecherche: String);
procedure TriosExclusifsIncomplets(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille; TypeRecherche : String);

//******************  procedures et functions secondaires *********************/

procedure ViderListeDecouvertes(var laliste : TListDec;var PosteCourant : Byte);
procedure MiseEnListeDecouverte(var laliste : TListDec;var PosteCourant : Byte;L,C,F,G: ShortInt; Cd,O,T,V : String);
Procedure MettreEnUnite(Var Unite : TUnite;Grille : TGrille; Numero : ShortInt; TypeUnite : String); // TypeUnite = L,C ou R
procedure PosteAZero(var TheTableau : TableauReponse);
procedure IncrementeCompteur(var TheTableau : TableauReponse; Candidats : String; ligne, Colonne : Integer);
procedure SommerOccurenceCandidat(var OccCand : TOccCand; Chaine : String);
Function  Sommer(GRille : Tgrille; Chiffre : String;Lig,Col,reg : Integer ): Integer;
Function  PremiereLigneRegion(Region : Integer):Integer;
Function  PremiereColonneRegion(Region :Integer):Integer;
Function  ColonneDansRegion(Colonne,Region :Integer):Boolean;
Function  LigneDansRegion(Ligne,Region :Integer):Boolean;
Function  CandidatExist(Grille : Tgrille;Ligne,Colonne:Integer;Candidat : String):Boolean;
function  RenvoiRegion(Ligne,Colonne : Integer): Integer ;
Function  PlaceEnregion(LigneouColonne : Integer): Integer;
function  SommerCandidatdifferent(OccCand : TOccCand):Integer;
function  AdditionnerCandidat(OccCand : TOccCand):Integer;




implementation



//******************************************//
//   Reste un candidat seul dans une case **//
//******************************************//
procedure CandidatSeulDansCase(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
Var
 I :Integer;
begin
 Nb := 0;
 For I := 1 to 81 do
  If length(Grille[I].cand) = 1 then
  begin
   MiseEnListeDecouverte(laliste,PosteCourant,Grille[I].Ligne,Grille[I].Colonne,0,Nb,
                         Grille[I].cand,'P','Le '+Grille[I].cand+
                         ' seul dans la case L'+IntToStr(Grille[I].Ligne)+
                         'C'+IntToStr(Grille[I].Colonne),'O');
   Inc(Nb);
  end;
end;

//**********************************************************
// Candidats present 1 fois dans une unit ligne colonne ou Region
//**********************************************************
procedure CandidatPresentUneFois(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;TypeRecherche :String);
Var
 RechercheCourante : Integer;
 Unite             : TUnite;
 TableauCourant    : TableauReponse;
 Texte             : String;
 CaseCourante      : Integer;
 I                 : Integer;
begin
 For RechercheCourante := 1 to 9 do // travail sur les 9 lignes/colonnes ou regions
 Begin

  PosteAZero(TableauCourant);
  MettreEnUnite(Unite,Grille,RechercheCourante,TypeRecherche);
  For CaseCourante := 1 to 9 do // pour tout les postes de l'unite
    IncrementeCompteur(TableauCourant,unite[CaseCourante].Candidats,unite[CaseCourante].Ligne, unite[CaseCourante].Colonne);

  // tests le tableau et si 1 ou plusieurs Candidats sont  1 mise dans la liste
  For I := 1 to 9 do
   If TableauCourant.Quantite[i] = 1 then
   begin
    Texte := 'Le '+IntTostr(I)+ ' seul sur la ';
    If TypeRecherche = 'L' then Texte := Texte + 'Ligne : '+IntToStr(TableauCourant.Ligne[I])+ ' Colonne : '+IntToStr(TableauCourant.Colonne[I]);
    If TypeRecherche = 'C' then Texte := Texte + 'Colonne : '+IntToStr(TableauCourant.Colonne[I])+ ' Colonne : '+IntToStr(TableauCourant.Colonne[I]);
    If TypeRecherche = 'R' then Texte := Texte + 'Region en L'+IntToStr(TableauCourant.Ligne[I])+ 'C'+IntToStr(TableauCourant.Colonne[I]);
    MiseEnListeDecouverte(laliste,PosteCourant,TableauCourant.Ligne[I],TableauCourant.Colonne[I],1,Nb,IntTostr(I),'P',texte,'O');
    Inc(Nb);
   End; // fin du if = 1
 end; // fin de travail sur cette unite
end;

//**********************************************************
//  Jumeaux et triples sur lignes
//**********************************************************
procedure JumeauxTriplesLignes(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
Var
 RegionCourante  : ShortInt;
 CandidatCourant : ShortInt;
 LigneCourante   : ShortInt;
 ColonneCourante : Shortint;
 LigneRegionCourante : ShortInt;
 SommeCandidatLigne  : ShortInt;
 SommeCandidatRegion : ShortInt;
 SommeCandidatLigneRegion : ShortInt;
 Voir : String[1];
begin
 For RegionCourante := 1 To 9 do
 Begin
  For CandidatCourant := 1 To 9 Do
  Begin
   SommeCandidatRegion := Sommer(grille,IntToStr(CandidatCourant),0,0,RegionCourante);
   For LigneRegionCourante := 1 to 3 do
   begin
    SommeCandidatLigneRegion := sommer(grille,IntToStr(CandidatCourant),LigneRegionCourante,0,RegionCourante);
    IF SommeCandidatLigneRegion >1 then //(2 ou 3)
    Begin
     IF SommeCandidatLigneRegion = SommeCandidatRegion then
     Begin
      LigneCourante := PremiereLigneRegion(RegionCourante)+LigneRegionCourante-1;
      SommeCandidatLigne := sommer(grille,IntToStr(CandidatCourant),LigneCourante,0,0);
      IF SommeCandidatLigne > SommeCandidatLigneRegion then
      Begin
       // ici il faut mettre en liste de decouverte
      Voir :='O';
       For ColonneCourante := 1 to 9 do
       Begin
        If CandidatExist(grille,LigneCourante,ColonneCourante,IntToStr(CandidatCourant)) then
        Begin
         If ColonneDansRegion(ColonneCourante,RegionCourante) then
         begin
           MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,2,Nb,
                         IntToStr(CandidatCourant),'V','Jumeaux/tripls de '+IntToStr(CandidatCourant)+
                         ' en L'+IntToStr(LigneCourante)+
                         'R'+IntToStr(RegionCourante),Voir);
          Voir :='N';
         end;
        end;
       End;// du for ColonneCourante

       For ColonneCourante := 1 to 9 do
       Begin
        If CandidatExist(grille,LigneCourante,ColonneCourante,IntToStr(CandidatCourant)) then
        Begin
         If not ColonneDansRegion(ColonneCourante,RegionCourante) then
         begin
           MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,2,Nb,
                         IntToStr(CandidatCourant),'C','Le '+IntToStr(CandidatCourant)+
                         ' supprim en L'+IntToStr(LigneCourante)+
                         'C'+IntToStr(ColonneCourante),'N');
         End;
        End;
       end;// du for
      Inc(Nb);
      End; //IF SommeCandidatLigne
     End; //IF SommeCandidatLigneRegion>
    End; //IF SommeCandidatLigneRegion=
   End; //for LigneRegionCourante
  End; // For CandidatCourant
 End; // for regionCourante
end;

//**********************************************************
// //Jumeaux et triples sur Colonnes
//**********************************************************
procedure JumeauxTriplesColonnes(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
Var
 RegionCourante  : ShortInt;
 CandidatCourant : ShortInt;
 LigneCourante   : ShortInt;
 ColonneCourante : Shortint;
 ColonneRegionCourante : ShortInt;
 SommeCandidatColonne  : ShortInt;
 SommeCandidatRegion : ShortInt;
 SommeCandidatColonneRegion : ShortInt;
 Voir : String[1];
begin
 For RegionCourante := 1 To 9 do
 Begin
  For CandidatCourant := 1 To 9 Do
  Begin
   SommeCandidatRegion := Sommer(grille,IntToStr(CandidatCourant),0,0,RegionCourante);
   For ColonneRegionCourante := 1 to 3 do
   begin
    SommeCandidatColonneRegion := sommer(grille,IntToStr(CandidatCourant),0,ColonneRegionCourante,RegionCourante);
    IF SommeCandidatColonneRegion >1 then //(2 ou 3)
    Begin
     IF SommeCandidatColonneRegion = SommeCandidatRegion then
     Begin
      ColonneCourante := PremiereColonneRegion(RegionCourante)+ColonneRegionCourante-1;
      SommeCandidatColonne := sommer(grille,IntToStr(CandidatCourant),0,ColonneCourante,0);
      IF SommeCandidatColonne > SommeCandidatColonneRegion then
      Begin
       // ici il faut mettre en liste
       Voir :='O';
       For LigneCourante := 1 to 9 do
       Begin
        If CandidatExist(grille,LigneCourante,ColonneCourante,IntToStr(CandidatCourant)) then
        Begin
         If LigneDansRegion(LigneCourante,RegionCourante) then
         begin
           MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,2,Nb,
                         IntToStr(CandidatCourant),'V','Jumeaux/tripls de '+IntToStr(CandidatCourant)+
                         ' en C'+IntToStr(ColonneCourante)+
                         'R'+IntToStr(RegionCourante),Voir);
          Voir :='N';
         End;
        End;
       End;// du for LigneCourante
       For LigneCourante := 1 to 9 do
       Begin
        If CandidatExist(grille,LigneCourante,ColonneCourante,IntToStr(CandidatCourant)) then
        Begin
         If not LigneDansRegion(LigneCourante,RegionCourante) then
         begin
          MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,2,Nb,
                         IntToStr(CandidatCourant),'C','Le '+IntToStr(CandidatCourant)+
                         ' supprim en L'+IntToStr(LigneCourante)+
                         'C'+IntToStr(ColonneCourante),'N');
         End;
        end;
       End;
      Inc(Nb);
      End; //IF SommeCandidatLigne
     End; //IF SommeCandidatLigneRegion>
    End; //IF SommeCandidatLigneRegion=
   End; //for LigneRegionCourante
  End; // For CandidatCourant
 End; // for regionCourante
end;

//**********************************************************
// //Interaction lignes et region
//**********************************************************
procedure InterActionlignesRegion(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
Var
 RegionCourante  : ShortInt;
 CandidatCourant : ShortInt;
 LigneCourante   : ShortInt;
 ColonneCourante : Shortint;
 LigneRegionCourante : ShortInt;
 SommeCandidatLigne  : ShortInt;
 SommeCandidatRegion : ShortInt;
 SommeCandidatLigneRegion : ShortInt;
 LaLigneTraitee : ShortInt;
 Voir : String[1];
begin
 For RegionCourante := 1 To 9 do
 Begin
  For CandidatCourant := 1 To 9 Do
  Begin
   SommeCandidatRegion := Sommer(grille,IntToStr(CandidatCourant),0,0,RegionCourante);
   For LigneRegionCourante := 1 to 3 do
   begin
    SommeCandidatLigneRegion := sommer(grille,IntToStr(CandidatCourant),LigneRegionCourante,0,RegionCourante);
    LigneCourante := PremiereLigneRegion(RegionCourante)+LigneRegionCourante-1;
    SommeCandidatLigne := sommer(grille,IntToStr(CandidatCourant),LigneCourante,0,0);
    If (SommeCandidatLigne >1) and( SommeCandidatLigneRegion =  SommeCandidatLigne) and ( SommeCandidatRegion > SommeCandidatLigneRegion) then
    begin
     For LaLigneTraitee  := PremiereLigneRegion(RegionCourante) to PremiereLigneRegion(RegionCourante)+ 2 do
     begin

      If LaLigneTraitee = ligneCourante then
      begin
       Voir :='O';
       For ColonneCourante := PremiereColonneRegion(RegionCourante) to  PremiereColonneRegion(RegionCourante)+2 do
       begin
        If CandidatExist(grille,LaLigneTraitee,ColonneCourante,IntToStr(CandidatCourant)) then
        begin
         MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,3,Nb,
           IntToStr(CandidatCourant),'V','Interaction du '+IntToStr(CandidatCourant)+ ' entre la ligne: '+IntToStr(LigneCourante)+
           ' et la Region: '+IntToStr(RegionCourante),Voir);
         Voir :='N';
        end;
       end;
      end;

      If LaLigneTraitee <> ligneCourante then
       For ColonneCourante := PremiereColonneRegion(RegionCourante) to  PremiereColonneRegion(RegionCourante)+2 do
        If CandidatExist(grille,LaLigneTraitee,ColonneCourante,IntToStr(CandidatCourant)) then
          MiseEnListeDecouverte(laliste,PosteCourant,LaLigneTraitee,ColonneCourante,3,Nb,IntToStr(CandidatCourant),'C',EmptyStr,'N');
     end;
    Inc(Nb);
    end;
   end;
  end;
 end;
End;

//**********************************************************
// Interaction Colonnes et region
//**********************************************************
procedure InterActionColonnesRegion(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille);
Var
 RegionCourante  : ShortInt;
 CandidatCourant : ShortInt;
 LigneCourante   : ShortInt;
 ColonneCourante : Shortint;
 ColonneRegionCourante : ShortInt;
 SommeCandidatColonne  : ShortInt;
 SommeCandidatRegion : ShortInt;
 SommeCandidatColonneRegion : ShortInt;
 LaColonneTraitee : ShortInt;
 Voir : String[1];
begin
 For RegionCourante := 1 To 9 do
 Begin
  For CandidatCourant := 1 To 9 Do
  Begin
   SommeCandidatRegion := Sommer(grille,IntToStr(CandidatCourant),0,0,RegionCourante);
   For ColonneRegionCourante := 1 to 3 do
   begin
    SommeCandidatColonneRegion := sommer(grille,IntToStr(CandidatCourant),0,ColonneRegionCourante,RegionCourante);
    ColonneCourante := PremiereColonneRegion(RegionCourante)+ColonneRegionCourante-1;
    SommeCandidatColonne := sommer(grille,IntToStr(CandidatCourant),0,ColonneCourante,0);
    If (SommeCandidatColonne > 1) and (SommeCandidatColonneRegion = SommeCandidatColonne) and (SommeCandidatRegion > SommeCandidatColonneRegion ) then
    begin
     Inc(Nb);
     For LaColonneTraitee  := PremiereColonneRegion(RegionCourante) to PremiereColonneRegion(RegionCourante)+ 2 do
     begin
      If LaColonneTraitee = ColonneCourante then
      begin
       Voir :='O';
       For LigneCourante := PremiereLigneRegion(RegionCourante) to  PremiereLigneRegion(RegionCourante)+2 do
        If CandidatExist(grille,LigneCourante,ColonneCourante,IntToStr(CandidatCourant)) then
        begin
         MiseEnListeDecouverte(laliste,PosteCourant,LigneCourante,ColonneCourante,3,Nb,
          IntToStr(CandidatCourant),'V','Interaction du '+IntToStr(CandidatCourant)+ ' entre la colonne : '+IntToStr(ColonneCourante)+
          ' et la rgion: '+IntToStr(RegionCourante),Voir);
         Voir :='N';
        end;
      end;
      If LaColonneTraitee <> ColonneCourante then
       For ligneCourante := PremiereLigneRegion(RegionCourante) to  PremiereLigneRegion(RegionCourante)+2 do
        If CandidatExist(grille,ligneCourante,LaColonneTraitee,IntToStr(CandidatCourant)) then
         MiseEnListeDecouverte(laliste,PosteCourant,ligneCourante,LaColonneTraitee,3,Nb,IntToStr(CandidatCourant),'C',EmptyStr,'N');
     end;
    end;
   end;
  end;
 end;
End;

//**********************************************************
// Gestion generique Doublets/Triplets/Quadruplerts  L C R
//**********************************************************
procedure ConfigurationsFranches(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;NbRecherche :ShortInt ;  TypeRecherche, chaine: String);
Var
 Unite             : Tunite;
 RechercheCourante : ShortInt;
 PosteUniteCourant : ShortInt;
 PosteUniteSuivant : ShortInt;
 CandidatCourant   : ShortInt;
 PosteTraite       : ShortInt;
 NBtrouve          : ShortInt;
 Voir              : String[1];
 Candidatpresent   : Boolean;
 ChaineTotal       : String[80];
begin
 For RechercheCourante := 1 To 9 Do
 Begin
  MettreEnUnite(Unite, Grille,RechercheCourante,TypeRecherche);
  For PosteUniteCourant := 1 to 8 do
  Begin
   IF Length(Unite[PosteUniteCourant].Candidats) = NbRecherche then
   begin
    NBtrouve := 1;
    For PosteUniteSuivant :=  PosteUniteCourant+1 to 9 do
     If Unite[PosteUniteCourant].Candidats = Unite[PosteUniteSuivant].Candidats then Inc(NBtrouve);

     If NBtrouve = NbRecherche then  // mise en liste
     Begin
      Candidatpresent := False;

      // tests si il existera des candidats a effacer sinon meme pas la peine de les mettre en liste
      For PosteTraite := 1 to 9 do
       If (Length(Unite[PosteTraite].Candidats) > 0 ) and (Unite[PosteTraite].Candidats <> Unite[PosteUniteCourant].Candidats) then
         For CandidatCourant := 1 to Length(Unite[PosteTraite].Candidats) do
          If Pos(Unite[PosteTraite].Candidats[CandidatCourant],Unite[PosteUniteCourant].Candidats)>0 then
           Candidatpresent := True;
      // fin de test puis gestion du test
      If Candidatpresent = True then
      Begin
       Voir := 'O';
       For PosteTraite := 1 to 9 do
        If (Length(Unite[PosteTraite].Candidats) > 0 ) and (Unite[PosteTraite].Candidats = Unite[PosteUniteCourant].Candidats) then
        begin
         If TypeRecherche = 'L' then ChaineTotal := Unite[PosteTraite].Candidats+Chaine+' la ligne   :'+ IntToStr(Unite[PosteTraite].Ligne);
         If TypeRecherche = 'C' then ChaineTotal := Unite[PosteTraite].Candidats+Chaine+' la colonne :'+ IntToStr(Unite[PosteTraite].Colonne);
         If TypeRecherche = 'R' then ChaineTotal := Unite[PosteTraite].Candidats+Chaine+' la rgion  :'+ intTostr(RenvoiRegion(Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne));

          MiseEnListeDecouverte(laliste,PosteCourant,Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne,4,Nb,'0','V',ChaineTotal,Voir);
          Voir :='N';
        end;
       For PosteTraite := 1 to 9 do
        If (Length(Unite[PosteTraite].Candidats) > 0 ) and (Unite[PosteTraite].Candidats <> Unite[PosteUniteCourant].Candidats) then
          For CandidatCourant := 1 to Length(Unite[PosteTraite].Candidats) do
           If Pos(Unite[PosteTraite].Candidats[CandidatCourant],Unite[PosteUniteCourant].Candidats)>0 then
             MiseEnListeDecouverte(laliste,PosteCourant,Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne,4,Nb,Unite[PosteTraite].Candidats[CandidatCourant],'C',IntToStr(CandidatCourant),'N');

      Inc(NB);
     end;
    End; // fin de mise en liste
   End;
  End;
 End;
end;

 //**********************************************************
// Gestion TriosExclusifsIncomplets  L C R
//**********************************************************
procedure TriosExclusifsIncomplets(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille; TypeRecherche : String);
Var
 Unite             : Tunite;
 Occ3Cases         : TOccCand;
 RechercheCourante : ShortInt;
 PremiereCase      : ShortInt;
 DeuxiemeCase      : ShortInt;
 TroisiemeCase     : ShortInt;
 NbdeCandidatDes3Cases :ShortInt;
 NbdeCandidatstrouve   :ShortInt;
 PosteTraite       :ShortInt;
 CandidatCourant   :ShortInt;
 Candidatpresent   :Boolean;
 ChaineCandidats   : String;
 Voir              : String[1];
 ChaineTotal       : String[80];
begin
 For RechercheCourante := 1 To 9 Do
 Begin
  MettreEnUnite(Unite, Grille,RechercheCourante,TypeRecherche);
  For PremiereCase := 1 to 7 do
  begin
   For DeuxiemeCase := PremiereCase+1 to 8 do
   begin
    For TroisiemeCase := DeuxiemeCase+1 to 9 do
    begin
     ChaineCandidats := Unite[PremiereCase].Candidats+ Unite[DeuxiemeCase].Candidats + Unite[TroisiemeCase].Candidats;
     If Unite[PremiereCase].Candidats  = EmptyStr then ChaineCandidats := EmptyStr;
     If Unite[DeuxiemeCase].Candidats  = EmptyStr then ChaineCandidats := EmptyStr;
     If Unite[TroisiemeCase].Candidats = EmptyStr then ChaineCandidats := EmptyStr;
     SommerOccurenceCandidat(Occ3Cases,ChaineCandidats);
     If SommerCandidatdifferent(Occ3Cases) = 3 then
     begin
      NbdeCandidatDes3Cases := AdditionnerCandidat(Occ3Cases);
      IF (NbdeCandidatDes3Cases>5) and (NbdeCandidatDes3Cases<9) then // entre 6  8
      begin
       //rechercher si il y a des candidats dans les autres cases sinon c'est pas la peine d'afficher
       Candidatpresent := False;
       NbdeCandidatstrouve := 0;
       For PosteTraite := 1 to 9 do
        If Unite[PosteTraite].Candidats <> EmptyStr then
         For CandidatCourant := 1 to Length(Unite[PosteTraite].Candidats) do
          If Pos(Unite[PosteTraite].Candidats[CandidatCourant],ChaineCandidats)> 0 then
           Inc(NbdeCandidatstrouve);
          If NbdeCandidatstrouve > NbdeCandidatDes3Cases then
           Candidatpresent := True;

        // fin de test puis gestion du test

       If Candidatpresent = True then
       Begin
        Voir := 'O';
        For PosteTraite := 1 to 9 do
         If (PosteTraite = PremiereCase)or(PosteTraite = DeuxiemeCase)or (PosteTraite = TroisiemeCase) then
         begin
          If TypeRecherche = 'L' then ChaineTotal :=  ' Trio franc incomplet sur la ligne   : '+ IntToStr(Unite[PosteTraite].Ligne);
          If TypeRecherche = 'C' then ChaineTotal :=  ' Trio franc incomplet sur la colonne : '+ IntToStr(Unite[PosteTraite].Colonne);
          If TypeRecherche = 'R' then ChaineTotal :=  ' Trio franc incomplet rgion  : '+ intTostr(RenvoiRegion(Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne));
          MiseEnListeDecouverte(laliste,PosteCourant,Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne,4,Nb,'0','V',ChaineTotal,Voir);
          Voir :='N';
         end;
         For PosteTraite := 1 to 9 do
          If  Unite[PosteTraite].Candidats  <> EmptyStr then
           If PosteTraite <> PremiereCase then
            If PosteTraite <> DeuxiemeCase then
             If PosteTraite <> TroisiemeCase then
              For CandidatCourant := 1 to Length(Unite[PosteTraite].Candidats) do
               If Pos(Unite[PosteTraite].Candidats[CandidatCourant],ChaineCandidats)> 0 then
                MiseEnListeDecouverte(laliste,PosteCourant,Unite[PosteTraite].Ligne,Unite[PosteTraite].Colonne,4,Nb,Unite[PosteTraite].Candidats[CandidatCourant],'C',IntToStr(CandidatCourant),'N');
         Inc(Nb);
        end;// if candidat

       end; // fin de mettre en liste
      end; // If SommerCandidatdifferent = 3
     end;
    end;
   end;
  end;
end;

//**********************************************************
// gestion Doublets Exclusifs
//**********************************************************
procedure DoubletsExlusifs(var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;TypeRecherche: String);
Var
 Unite             : Tunite;
 OccCand           : TOccCand;
 RechercheCourante : ShortInt;
 PremiereCase      : ShortInt;
 DeuxiemeCase      : ShortInt;
 I                 : ShortInt;
 Occ2Cases         : TOccCand;
 ChaineUnite       : String;
 PosteUniteCourant : ShortInt;
 CandidatTrouver   : String;
 NombreOccurence   : ShortInt;
 ChaineTotal       :String[80];
 Voir              :string[1];
begin
 For RechercheCourante := 1 To 9 Do
 Begin
  MettreEnUnite(Unite, Grille,RechercheCourante,TypeRecherche);
  // tout les candidats dans une chaine
  ChaineUnite := EmptyStr;
  For I := 1 to 9 Do
   ChaineUnite := ChaineUnite + Unite[I].Candidats;
  // sommer les candidats par candidats
  SommerOccurenceCandidat(OccCand,ChaineUnite);
  For PremiereCase := 1 to 8 do
  begin
   For DeuxiemeCase := PremiereCase+1 to 9 do
   begin
    SommerOccurenceCandidat(Occ2Cases,Unite[PremiereCase].Candidats +Unite[DeuxiemeCase].Candidats);
    CandidatTrouver  := EmptyStr;
    NombreOccurence  := 0;
    For PosteUniteCourant := 1 to 9 do
     If (Occ2Cases[PosteUniteCourant] = 2) and (OccCand[PosteUniteCourant] = 2) then
      begin
       CandidatTrouver := CandidatTrouver + IntTostr(PosteUniteCourant);
       Inc(NombreOccurence);
      End; // du if (OccCand[PosteCourantPosteUniteCourant] > 1
    If NombreOccurence = 2 then
    begin
     // recherche  si il y'a des candidats a enlever
     If not ((Unite[PremiereCase].Candidats = CandidatTrouver) and (Unite[DeuxiemeCase].Candidats = CandidatTrouver)) then
     begin
      Voir :='O';
      For I := 1 to length(Unite[PremiereCase].Candidats) do
       If Pos(Unite[PremiereCase].Candidats[I],CandidatTrouver)>0 then
       begin
        If TypeRecherche = 'L' then ChaineTotal := CandidatTrouver +  ' En doublet exclusif sur la ligne : '+ IntToStr(Unite[PremiereCase].Ligne);
        If TypeRecherche = 'C' then ChaineTotal := CandidatTrouver +  ' En doublet exclusif sur la colonne : '+ IntToStr(Unite[PremiereCase].Colonne);
        If TypeRecherche = 'R' then ChaineTotal := CandidatTrouver +  ' En doublet exclusif sur la rgion : '+ IntToStr(RenvoiRegion(Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne));
        MiseEnListeDecouverte(laliste,PosteCourant,Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne,5,Nb,Unite[PremiereCase].Candidats[I],'V',ChaineTotal,Voir);
        Voir := 'N';
       end;

      For I := 1 to length(Unite[DeuxiemeCase].Candidats) do
       If Pos(Unite[DeuxiemeCase].Candidats[I],CandidatTrouver)>0 then
        MiseEnListeDecouverte(laliste,PosteCourant,Unite[DeuxiemeCase].Ligne,Unite[DeuxiemeCase].Colonne,5,Nb,Unite[DeuxiemeCase].Candidats[I],'V',EmptyStr,'N');


      For I := 1 to length(Unite[PremiereCase].Candidats) do
       If Pos(Unite[PremiereCase].Candidats[I],CandidatTrouver)=0 then
        MiseEnListeDecouverte(laliste,PosteCourant,Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne,5,Nb,Unite[PremiereCase].Candidats[I],'C',EmptyStr,'N');

      For I := 1 to length(Unite[DeuxiemeCase].Candidats) do
       If Pos(Unite[DeuxiemeCase].Candidats[I],CandidatTrouver)=0 then
        MiseEnListeDecouverte(laliste,PosteCourant,Unite[DeuxiemeCase].Ligne,Unite[DeuxiemeCase].Colonne,5,Nb,Unite[DeuxiemeCase].Candidats[I],'C',EmptyStr,'N');

      Inc(NB);
     end;
    end;
   End;//If NombreOcc = 2
  End; //for deuxieme Case
 End; // for Premier Case
End;

//**********************************************************
// gestion Triplets Exclusifs
//**********************************************************
procedure TripletsExlusifs (var laliste : TListDec;var PosteCourant : Byte;var Nb :ShortInt; Grille : TGrille;TypeRecherche: String);
Var
 Unite             : Tunite;
 OccCand           : TOccCand;
 RechercheCourante : ShortInt;
 PremiereCase      : ShortInt;
 DeuxiemeCase      : ShortInt;
 TroisiemeCase     : ShortInt;
 I                 : ShortInt;
 Occ3Cases         : TOccCand;
 ChaineUnite       : String;
 Chaine3Cases      : String;
 ExistCandidat     : Boolean;
 NbOccCandidatCourant :ShortInt;
 PosteUniteCourant : ShortInt;
 CandidatTrouver   : String;
 NombreOccurence   : ShortInt;
 ChaineTotal       : String[80];
  Voir             : String[1];
begin
 For RechercheCourante := 1 To 9 Do
 Begin
  MettreEnUnite(Unite, Grille,RechercheCourante,TypeRecherche);
  // tout les candidats dans une chaine
  ChaineUnite := EmptyStr;
  For I := 1 to 9 Do
   ChaineUnite := ChaineUnite + Unite[I].Candidats;
  // sommer les candidats par candidats
  SommerOccurenceCandidat(OccCand,ChaineUnite);
  For PremiereCase := 1 to 7 do
  begin
   For DeuxiemeCase := PremiereCase+1 to 8 do
   begin
    For troisiemeCase := DeuxiemeCase+1 to 9 do
    begin
     Chaine3Cases := Unite[PremiereCase].Candidats +Unite[DeuxiemeCase].Candidats+Unite[TroisiemeCase].Candidats;
     SommerOccurenceCandidat(Occ3Cases,Chaine3Cases);
     // rechercher si lil y aura des candidats a supprimer
     ExistCandidat := False;
     If Unite[PremiereCase].Candidats <> EmptyStr then
      For I := 1 to length(Unite[PremiereCase].Candidats) do
        If Pos(Unite[PremiereCase].Candidats[I],Chaine3Cases)=0 then
         ExistCandidat := True;
      For I := 1 to length(Unite[DeuxiemeCase].Candidats) do
        If Pos(Unite[DeuxiemeCase].Candidats[I],Chaine3Cases)=0 then
         ExistCandidat := True;
      For I := 1 to length(Unite[TroisiemeCase].Candidats) do
        If Pos(Unite[TroisiemeCase].Candidats[I],Chaine3Cases)=0 then
         ExistCandidat := True;



     CandidatTrouver  := EmptyStr;
     NombreOccurence  := 0;
     For PosteUniteCourant := 1 to 9 do
     begin
      NbOccCandidatCourant := Occ3Cases[PosteUniteCourant];
      IF (NbOccCandidatCourant >1) and (NbOccCandidatCourant<4) and (NbOccCandidatCourant = OccCand[PosteUniteCourant])  then // entre 2 et 3
      begin
       CandidatTrouver := CandidatTrouver + IntTostr(PosteUniteCourant);
       Inc(NombreOccurence);
       End; // du if (NbOccCandidatCourant >1)
     end;

     If (NombreOccurence = 3) and (ExistCandidat) then
     begin
      If not ((Unite[PremiereCase].Candidats = CandidatTrouver) and (Unite[DeuxiemeCase].Candidats = CandidatTrouver) and (Unite[TroisiemeCase].Candidats = CandidatTrouver)) then
      begin
       Voir := 'O';
       For I := 1 to length(Unite[PremiereCase].Candidats) do
        If Pos(Unite[PremiereCase].Candidats[I],CandidatTrouver)>0 then
        begin
         If TypeRecherche = 'L' then ChaineTotal := CandidatTrouver +  ' En Trio exclusif sur la ligne : '+ IntToStr(Unite[PremiereCase].Ligne);
         If TypeRecherche = 'C' then ChaineTotal := CandidatTrouver +  ' En Trio exclusif sur la colonne : '+ IntToStr(Unite[PremiereCase].Colonne);
         If TypeRecherche = 'R' then ChaineTotal := CandidatTrouver +  ' En Trio exclusif sur la rgion : '+ IntToStr(RenvoiRegion(Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne));
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne,5,Nb,Unite[PremiereCase].Candidats[I],'V',ChaineTotal,Voir);
         Voir := 'N';
        end;

       For I := 1 to length(Unite[DeuxiemeCase].Candidats) do
        If Pos(Unite[DeuxiemeCase].Candidats[I],CandidatTrouver)>0 then
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[DeuxiemeCase].Ligne,Unite[DeuxiemeCase].Colonne,5,Nb,Unite[DeuxiemeCase].Candidats[I],'V',EmptyStr,'N');

       For I := 1 to length(Unite[TroisiemeCase].Candidats) do
        If Pos(Unite[TroisiemeCase].Candidats[I],CandidatTrouver)>0 then
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[TroisiemeCase].Ligne,Unite[TroisiemeCase].Colonne,5,Nb,Unite[TroisiemeCase].Candidats[I],'V',EmptyStr,'N');

       For I := 1 to length(Unite[PremiereCase].Candidats) do
        If Pos(Unite[PremiereCase].Candidats[I],CandidatTrouver)=0 then
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[PremiereCase].Ligne,Unite[PremiereCase].Colonne,5,Nb,Unite[PremiereCase].Candidats[I],'C',EmptyStr,'N');

       For I := 1 to length(Unite[DeuxiemeCase].Candidats) do
        If Pos(Unite[DeuxiemeCase].Candidats[I],CandidatTrouver)=0 then
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[DeuxiemeCase].Ligne,Unite[DeuxiemeCase].Colonne,5,Nb,Unite[DeuxiemeCase].Candidats[I],'C',EmptyStr,'N');

       For I := 1 to length(Unite[TroisiemeCase].Candidats) do
        If Pos(Unite[TroisiemeCase].Candidats[I],CandidatTrouver)=0 then
         MiseEnListeDecouverte(laliste,PosteCourant,Unite[TroisiemeCase].Ligne,Unite[TroisiemeCase].Colonne,5,Nb,Unite[TroisiemeCase].Candidats[I],'C',EmptyStr,'N');
      Inc(NB);
      end;
     End; // fin occu = 3
    End; //for Troisieme Case
   End; //for deuxieme Case
  End; //for premiere Case
 End;//Du for recherche courante
End;





          ///************************************************///
          ///    Procedures et fonctions secondaires         ///
          ///************************************************///



//******************************************************************//
// vider toutes les decouvertes faites de la liste des decouvertes *//
//******************************************************************//
procedure ViderListeDecouvertes(var laliste : TListDec;var PosteCourant : Byte);
Var
 I :Integer;
begin
 If PosteCourant = 0 then Exit;
 For I := 0 to PosteCourant do
 Begin
  laliste[I].Ligne     := 0;  laliste[I].Colonne   := 0;
  laliste[I].Candidat  := EmptyStr; laliste[I].Operation := EmptyStr;
  laliste[I].Famille   := 0;  laliste[I].Groupe    := 0;
  laliste[I].Texte     := EmptyStr;
 End;
 PosteCourant := 0;
end;

//*******************************************************//
// Placer une decouverte  dans la liste des decouvertes *//
//*******************************************************//
procedure MiseEnListeDecouverte(var laliste : TListDec;var PosteCourant : Byte;L,C,F,G: ShortInt;Cd,O,T,V: String);
begin
 inc(PosteCourant);
 laliste[PosteCourant].Ligne     := L;  laliste[PosteCourant].Colonne   := C;
 laliste[PosteCourant].Candidat  := Cd; laliste[PosteCourant].Operation := O;
 laliste[PosteCourant].Famille   := F;  laliste[PosteCourant].Groupe    := G;
 laliste[PosteCourant].Texte     := T;  laliste[PosteCourant].Vue       := V;
end;

//*****************************************************
// fonction qui renvoi 1 2 ou 3 en fonction de la place
// de la ligne ou la colonne dans une region
//*****************************************************
function PlaceEnregion(LigneouColonne : Integer): Integer;
Begin
 If (LigneouColonne <= 3) then
   result := LigneouColonne;
 If (LigneouColonne >=4) and (LigneouColonne <= 6) then
   result := LigneouColonne -3;
 If (LigneouColonne >=7) then
   result := LigneouColonne -6;
End;

//*********************************************************
// Procedure qui place une ligne,une colonne ou une region
// dans un record nomm unite, c'est plus simple pour bosser
// et surtout cela permet d'utiliser la mme fonction pour
// une ligne une colonne ou une region
//*********************************************************
Procedure MettreEnUnite(Var Unite : TUnite;Grille : TGrille; Numero : ShortInt; TypeUnite : String); // TypeUnite = L,C ou R
Var
 CaseCourante : ShortInt;
 PosteCourant : ShortInt;
 Prendre      : Boolean;
Begin
 PosteCourant := 0;
 For CaseCourante := 1 to 81 do
 Begin
  Prendre := False;
  If (TypeUnite = 'R') and(Grille[CaseCourante].Region  = Numero) then Prendre := True;
  If (TypeUnite = 'L') and(Grille[CaseCourante].Ligne   = Numero) then Prendre := True;
  If (TypeUnite = 'C') and(Grille[CaseCourante].Colonne = Numero) then Prendre := True;
  If prendre Then
  Begin
   Inc(PosteCourant);
   Unite[PosteCourant].Ligne     := Grille[CaseCourante].Ligne;
   Unite[PosteCourant].Colonne   := Grille[CaseCourante].Colonne;
   Unite[PosteCourant].Candidats := Grille[CaseCourante].cand;
  End;
 End;
End;

//*****************************************************
// Met tous les postes d'un tableau  zero
//*****************************************************
procedure PosteAZero(var TheTableau : TableauReponse);
Var
 I :Integer;
begin
 For I :=  1 to 9 do
 begin
  TheTableau.Ligne[I]    :=0;
  TheTableau.Colonne[I]  :=0;
  TheTableau.Quantite[I] :=0;
 end;
end;



//*****************************************************
// Incremente les compteurs du tableau en fonction des
// Candidats trouvs dans la chaine
// Utilis en famille  1 2 et 3
//*****************************************************
procedure IncrementeCompteur(var TheTableau : TableauReponse; Candidats : String; ligne, Colonne : Integer);
Var
 i,poste :Integer;
begin
 If Candidats = EmptyStr then
  Exit;
 For i := 1 to length(Candidats) do
 begin
 poste := StrToInt(Candidats[i]);
  TheTableau.Quantite[poste] := TheTableau.quantite[poste] + 1;
  TheTableau.Colonne[poste]  := Colonne;
  TheTableau.Ligne[poste]    := Ligne;
 end;
end;

//*****************************************************
// Charge Le tableau OccCand du nombre d'occurence
// de chanque candidats d'une unite
// le poste du tableau = candidat
//*****************************************************
procedure SommerOccurenceCandidat(var OccCand : TOccCand; Chaine : String);
Var
 I : Integer;
begin
 For I := 1 to 9 do OccCand[I] := 0; // tout a zero
 For I := 1 to Length(Chaine) do
  inc(OccCand[StrToInt(Chaine[I])]);
End;

//*****************************************************
// Compte combien il y de candidats diffents dans un
// tableau ToccCand
//*****************************************************
function SommerCandidatdifferent(OccCand : TOccCand):Integer;
Var
 I : Integer;
begin
 Result := 0 ;
 For I := 1 to 9 do
 If OccCand[I] > 0 then
  Inc(Result);
End;

//*****************************************************
// Additionne tous les candidats d'un ToccCand
//*****************************************************
function AdditionnerCandidat(OccCand : TOccCand):Integer;
Var
 I : Integer;
begin
 Result := 0 ;
 For I := 1 to 9 do
  Result := Result + OccCand[I];
End;


//**************************************************************
//Renvoi True si la colonne fait partie de la region
//**************************************************************
Function ColonneDansRegion(Colonne,Region :Integer):Boolean;
Begin
 Result := False;
 If Pos(IntToStr(Colonne),'123')>0 then
  If Pos(IntToStr(Region),'147')>0  then
   Result := True;
 If Pos(IntToStr(Colonne),'456')>0  then
  If Pos(IntToStr(Region),'258')>0  then
   Result := True;
 If Pos(IntToStr(Colonne),'789')>0  then
  If Pos(IntToStr(Region),'369')>0  then
   Result := True;
End;

//**************************************************************
//Renvoi True si la ligne fait partie de la region
//**************************************************************
Function LigneDansRegion(Ligne,Region :Integer):Boolean;
Begin
 Result := False;
 If Pos(IntToStr(Ligne),'123')>0 then
  If Pos(IntToStr(Region),'123')>0  then
   Result := True;
 If Pos(IntToStr(Ligne),'456')>0  then
  If Pos(IntToStr(Region),'456')>0  then
   Result := True;
 If Pos(IntToStr(Ligne),'789')>0  then
  If Pos(IntToStr(Region),'789')>0  then
   Result := True;
End;

//**************************************************************
// Fonction CandidatExist renvoi True si le Candidat existe pour
// cette ligne et cette colonne
//**************************************************************
Function CandidatExist(Grille : Tgrille;Ligne,Colonne:Integer;Candidat : String):Boolean;
Var
 I :Integer;
Begin
 Result := False;
 For I := 1  to 81  do
 begin
  If Grille[i].Ligne = Ligne then
   If Grille[i].Colonne = Colonne then
    If Pos(Candidat,Grille[i].cand)> 0 then Result := true;
 End;
End;

//**************************************************************
// Fonction qui renvoi le N de la Premire ligne d'une region
//**************************************************************
Function PremiereLigneRegion(Region:Integer):Integer;
Begin
 IF Region < 4   then Result := 1;
 IF (Region >3)  then
   IF (Region < 7) then Result := 4;
 IF (Region >6)  then Result := 7;
End;
//**************************************************************
// Fonction qui renvoi le N de la Premire Colonne d'une region
//**************************************************************
Function PremiereColonneRegion(Region:Integer):Integer;
Begin
 If Pos(IntToStr(Region),'147')>0 then Result := 1;
 If Pos(IntToStr(Region),'258')>0 then Result := 4;
 If Pos(IntToStr(Region),'369')>0 then Result := 7;
End;

//************************************************************
// fonction generique qui somme les occurences d'un candidat:
// d'une ligne
// d'une colonne
// D'une region
// d'une ligne d'une region (pour les alignements (jumeau/triplet))
// d'une colonne d'une region (pour les alignements (jumeau/triplet))
//************************************************************
function  Sommer(Grille : Tgrille; Chiffre : String;Lig,Col,reg : Integer ): Integer;
Var
 CaseCourante : Integer;
begin
 Result := 0;
 IF reg = 0 then // somme sur ligne ou colonne
 begin
  If Lig > 0 Then // somme d'une ligne
  Begin
   For CaseCourante := 1 to 81 do
    If Grille[caseCourante].Ligne = lig then
     If Pos(Chiffre,Grille[caseCourante].cand)>0 then
       inc(Result);
   End
  else // somme d'une colonne
  begin
   For CaseCourante := 1 to 81 do
    If Grille[caseCourante].Colonne = Col then
     If Pos(Chiffre,Grille[caseCourante].cand)>0 then
       inc(Result);
  end;
 end
 else // Somme sur region
 begin
  If (lig+col) = 0 then  // Somme total de la region
  begin
   For CaseCourante := 1 to 81 do
    If Grille[caseCourante].Region = reg then
     If Pos(Chiffre,Grille[caseCourante].cand)>0 then
       inc(Result);
  end
  Else
  Begin // somme le partie de region
   If Lig>0 then // somme d'une ligne d'une region (13)
   begin
   For CaseCourante := 1 to 81 do
    If Grille[caseCourante].LigReg  = lig then
     If Grille[caseCourante].Region  = reg then
      If Pos(Chiffre,Grille[caseCourante].cand)>0 then
        inc(Result);
   end
   else
   begin // somme d'une Colonne d'une region (13)
   For CaseCourante := 1 to 81 do
    If Grille[caseCourante].ColReg  = col then
     If Grille[caseCourante].Region  = reg then
      If Pos(Chiffre,Grille[caseCourante].cand)>0 then
        inc(Result);
   end;
  end;
 end;
End;

//*************************************************************************
// precise pour une case sa region en fonction de sa ligne etde sa region
//*************************************************************************
function RenvoiRegion(Ligne,Colonne : Integer): Integer ;
begin
 Result := Ceil(Colonne/3)+((ceil(Ligne/3)-1)*3);
end;

end.

