unit UDmFonction;

interface

uses
  SysUtils,Classes,Forms,ShlObj,Windows,ActiveX,Inifiles,buttons,Comctrls,
  StdCtrls,ExtCtrls,Menus,Dialogs,Controls,ActnList,ActnMan,ExtActns,
  shellApi,uxTheme;

Const
 NOMPUBLIC = 'Sudoku Trainer'; // nom public de l'application connue dans Windows
 SETTING   = 'Setting.ini';    // Nom du fichier INI
 ASTUCE    = 'Astuces.txt';    // Nom du fichier des asctuces
 NONAME    = 'SansNom';        // Racine des noms de fichier non encore nomms
 EXTSDT    = 'sdt';            // Extension des fichiers pour le programme
 EXTTXT    = 'txt';            // Extension des fichiers de type texte
 TIMEEMPTY = '00:00:00';       // affich lorsque le timer n'est pas actif
 SPACES    = Chr(127)+Chr(127)+Chr(127)+Chr(127); // un peu d'espace

ResourceString
 Message001 = 'Ne peut pas pointer sur l''interface IMalloc.';
 Message002 = 'Le fichier %s a t enregistr avec succs.';
 Message003 = 'La grille %s   t modifie depuis sa cration ou son chargement';
 Message004 = 'Attention le calcul peut durer un peu !';
 Message005 = 'Fichier non trouv : ';
 Message006 = 'Enregistrer sous...';
 Message007 = 'Fichiers SDT';
 Message008 = 'Voulez-vous enregistrer la grille ?';
 Message009 = 'Confirmez l''effacement total de la grille ?';
 Message010 = 'Recommencez la grille ?';
 Message011 = 'Sudoku non rcuparable,81 Caractres attendus';
 Message012 = 'La grille n''est pas vide';
 Message013 = 'Voulez-vous une grille gnre ?';
 Message014 = 'Le fichier %s existe dj.'+ #13#10+ 'Voulez-vous  l''craser ?';
 Message015 = 'Fichiers TXT';
 Message016 = 'Pas de solution';
 Message017 = 'Plusieurs solutions possibles ';
 Message018 = 'Solution trouve. Dure du calcul en secondes : ';




type

 // Record d'une action
 TActionSudoku  = record
   Ligne     : ShortInt;
   Colonne   : ShortInt;
   Chiffre   : ShortInt;
   Operation : String[1];
  End;

 // un simple tableau pour le BackCraking
 TSuDoKuBackCrack = array [1..9,1..9] of
 record
  Valeur : integer;
  Trouve : boolean
 end;


 TDMFonction = class(TDataModule)
   procedure DataModuleCreate(Sender: TObject);
   procedure DataModuleDestroy(Sender: TObject);

  private
    { Dclarations prives }

   WinPosCorrection       : Array[0..5] of TPoint;
   RecentFiles            : TStringList; // liste des fichiers ouverts recemment
   RecentFilesMICounter   : integer;     // utilis pour nomm les items

   function GetGlobalSettingsPath : string;
   function GetSpecialFolder(Folder: Integer): String;

  public
    { Dclarations publiques }

   SettingsPath       : String;  // Chemin pour les datas dans mes documents
   Chemin             : String;  // Chemin de l'application
   RecentOpenFileDir  : String;  // Nom du dernier fichier ouvert
   ReopenLastFile     : Boolean; // Rouvrir le dernier fichier ouvert au lancement O/N
   ShowTipsOnStartup  : Boolean; // Voir les astuces au lancement O/N
   SavePosWin         : Boolean; // Sauver la position des fentres O/N
   Toolbar_Visible    : Boolean; // Voir la barre d'outils O/N
   QuitConfirm        : Boolean; // Confirmer pour quitter O/N
   CandidatsOnOff     : Boolean; // Voir les candidats O/N
   ProtectionOnOff    : Boolean; // Mode protection des erreurs O/N
   LastTipShown       : Integer; // N de la derniere astuce affiche
   TimeSplash         : Integer; // Dure de la Splash en seconde
   NonameCounter      : integer; // Prochain n a donner  une grille
   // les couleurs de chiffres
   CouleurChiffre     : integer;
   CouleurDevoile     : Integer;
   CouleurCandidat    : Integer;
   CouleurJouable     : Integer;
   CouleurReference   : Integer;

   procedure AppelBrowser(Chemin : String);
   procedure SaveWinPos(win: TForm; DoSize: Boolean);
   procedure RestoreWinPos(win: TForm; DoSize: Boolean);
   procedure OpenRecentFile(Sender: TObject);
   procedure AddFileToRecentFilesList(fname: string);
   procedure SaveValueInSettingsIniFile(section, name, value: string);
   procedure LoadFromIniFile;
   procedure SaveToIniFile;
   function  GetRecentFileCount: integer;
   function  GetRecentFileName(id: integer): string;
   function  GetNextNonameNumber: String;
   function  LoadValueFromSettingsIniFile(section, name, default: string): string;
   function  RenvoiVersion():String;
   function  SecondeToTemps(lesSecondes : Integer):String;
   function  ChargerAstuce: string;
   function  NomAleat(Lg : Integer): String;
   function  Aleatoire(Num1,Num2:integer):integer;
   function  ThemeAndVista(): Boolean;
 end;

var
  DMFonction: TDMFonction;

implementation

uses UMain;


{$R *.dfm}

// Initialisation et chargement du contexte de l'application
procedure TDMFonction.DataModuleCreate(Sender: TObject);
Var
 I : Integer; // Pour la boucle FOR
begin
 // liste des fichiers recents
 RecentFiles          := TStringList.Create;
 // chemin de l'application
 Chemin               := ExtractFilePath(Application.ExeName);
 // chemin dans documents du compte utilisateur
 SettingsPath         := GetGlobalSettingsPath();
 // cration (eventuelle) du repertoire
 ForceDirectories(SettingsPath);
 RecentOpenFileDir    := EmptyStr;
 RecentFilesMICounter := 1;
 NonameCounter        := 0;
 // Initialisation d'un tableau de TPoint pour la
 // correction du positionnement des fentres
 for i:=0 to 5 do
  WinPosCorrection[i] := Point(0,0);
 // chargement des variables globales sauvegardes
 // dans un fichier INI
 LoadFromIniFile();
End;

// Sauvegarde du contexte et libration des ressources
procedure TDMFonction.DataModuleDestroy(Sender: TObject);
begin
 // sauver les variables globales dans un fichier INI
 SaveToIniFile;
 // liberation des ressources
 RecentFiles.Free;
end;

// Construction du chemin de sauvegardes
function TDMFonction.GetGlobalSettingsPath(): string;
begin
  //chemin (par dfaut) du repertoire de sauvegarde des
  //grilles et du INI dans le compte utilisateur
  GetGlobalSettingsPath := GetSpecialFolder(CSIDL_COMMON_DOCUMENTS)+PathDelim+NomPublic+PathDelim;
end;

// Utile a GetGlobalSettingsPath
function TDMFonction.GetSpecialFolder(Folder: Integer): String;
var
  pMalloc: IMalloc;
  pidl: PItemIDList;
  Path: PChar;
begin
  if (SHGetMalloc(pMalloc) <> S_OK) then
  begin
   raise EInOutError.Create(Message001);
   Exit;
  end;
  SHGetSpecialFolderLocation(0, Folder, pidl);
  GetMem(Path, MAX_PATH);
  SHGetPathFromIDList(pidl, Path);
  Result := Path;
  FreeMem(Path);
  pMalloc.Free(pidl);
end;

// chargement d'une URL,URI ou fichier fichier local
// dans l'explorateur courant de Windows
procedure TDMFonction.AppelBrowser(Chemin : String);
Var
 browser :TbrowseURL;
begin
 Try
  browser := TBrowseURL.Create(self);
  browser.URL := Chemin;
  browser.ExecuteTarget(self);
 finally
  browser.Free;
 end;
end;

// Renvoi le numero de version de l'application
Function TDMFonction.RenvoiVersion():String;
var
 FileName: string;
 InfoSize, Wnd: DWORD;
 VerBuf: Pointer;
 FI: PVSFixedFileInfo;
 VerSize: DWORD;
begin
 Result  := EmptyStr;
 FileName := Application.ExeName;
 InfoSize := GetFileVersionInfoSize(PChar(FileName), Wnd);
 if InfoSize <> 0 then
 begin
  GetMem(VerBuf, InfoSize);
  try
   if GetFileVersionInfo(PChar(FileName), Wnd, InfoSize, VerBuf) then
    if VerQueryValue(VerBuf, PathDelim, Pointer(FI), VerSize) then
    Begin
     Result  := InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionMS,8),1,4)));
     Result  := Result +'.'+InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionMS,8),5,4)));
     Result  := Result + InttoStr(StrToInt(Copy(IntToHex(FI.dwFileVersionLS,8),1,4)));
    end;
  finally
   FreeMem(VerBuf);
  end;
 end;
end;

// Fonction generique de lecture dans le Ini
function TDMFonction.LoadValueFromSettingsIniFile(section, name, default: string): string;
var
 theIni: TIniFile;
begin
  //Read IniFile
  theIni:=TIniFile.Create(SettingsPath+SETTING);
  try
   LoadValueFromSettingsIniFile:=  theIni.ReadString(section, name, default);
  finally
   theIni.Free;
  end;
end;

// Fonction generique d'ecriture dans le Ini
procedure TDMFonction.SaveValueInSettingsIniFile(section, name, value: string);
var
 theIni: TIniFile;
begin
  //Write IniFile
  theIni:=TIniFile.Create(SettingsPath+SETTING);
  try
    theIni.WriteString(section, name, value);
    theIni.UpdateFile;
  finally
    theIni.Free;
  end;
end;

// Chargement des variables globales depuis le Ini
procedure TDMFonction.LoadFromIniFile;
var
 theIni : TIniFile;
begin
  try
   theIni := TIniFile.Create(SettingsPath+SETTING);
   ShowTipsOnStartup :=theIni.ReadBool('GeneralSettings', 'ShowTipsOnStartup', True);
   SavePosWin        :=theIni.ReadBool('GeneralSettings', 'SavePosWin',True);
   Toolbar_Visible   :=theIni.ReadBool('GeneralSettings', 'ToolBar',True);
   QuitConfirm       :=theIni.ReadBool('GeneralSettings', 'QuitConfirm',True);
   LastTipShown      :=theIni.ReadInteger('GeneralSettings', 'LastTipShown', 0);
   TimeSplash        :=theIni.ReadInteger('GeneralSettings', 'TimeSplash', 2);
   ReopenLastFile    :=theIni.ReadBool('GeneralSettings', 'ReopenLastFile',True);
   RecentOpenFileDir :=theIni.ReadString('RecentDirectories', 'RecentOpenFileDir', EmptyStr);
   CouleurChiffre    :=theIni.ReadInteger('GeneralSettings', 'CouleurChiffre', 16711680);
   Couleurdevoile    :=theIni.ReadInteger('GeneralSettings', 'Couleurdevoile', 0);
   CouleurCandidat   :=theIni.ReadInteger('GeneralSettings', 'CouleurCandidat', 16744576);
   CouleurReference  :=theIni.ReadInteger('GeneralSettings', 'CouleurReference', 65535);
   CouleurJouable    :=theIni.ReadInteger('GeneralSettings', 'CouleurJouable', 65408);
   CandidatsOnOff    :=theIni.ReadBool('GeneralSettings', 'Candidats',False);
   ProtectionOnOff   :=theIni.ReadBool('GeneralSettings', 'Protection',False);
  finally
   theIni.Free;
  end;
  // si RecentOpenFileDir est vide on prend le chemin par defaut dans documents du compte user
  if(RecentOpenFileDir =  EmptyStr)then
   RecentOpenFileDir  := SettingsPath;
end;

// Sauvegarde des variables globales dans le Ini
procedure TDMFonction.SaveToIniFile;
var
 TheIni : TIniFile;
 I      : Integer;
begin
  theIni:=TIniFile.Create(SettingsPath+SETTING);
  try
   theIni.WriteBool('GeneralSettings', 'ShowTipsOnStartup',ShowTipsOnStartup);
   theIni.WriteBool('GeneralSettings', 'SavePosWin',SavePosWin);
   theIni.WriteBool('GeneralSettings', 'ToolBar',Toolbar_Visible);
   theIni.WriteBool('GeneralSettings', 'QuitConfirm',QuitConfirm);
   theIni.WriteInteger('GeneralSettings', 'LastTipShown',LastTipShown);
   theIni.WriteInteger('GeneralSettings', 'TimeSplash',TimeSplash);
   theIni.WriteBool('GeneralSettings', 'ReopenLastFile',ReopenLastFile);
   theIni.WriteString('RecentDirectories', 'RecentOpenFileDir', RecentOpenFileDir);
   theIni.WriteInteger('GeneralSettings', 'CouleurChiffre',CouleurChiffre);
   theIni.WriteInteger('GeneralSettings', 'CouleurCandidat',CouleurCandidat);
   theIni.WriteInteger('GeneralSettings', 'Couleurdevoile',Couleurdevoile);
   theIni.WriteInteger('GeneralSettings', 'CouleurJouable',CouleurJouable);
   theIni.WriteInteger('GeneralSettings', 'CouleurReference',CouleurReference );
   theIni.WriteBool('GeneralSettings', 'Candidats',CandidatsOnOff );
   theIni.WriteBool('GeneralSettings', 'Protection',ProtectionOnOff);
   // sauvegarde de la liste des dernires grilles joues
   theIni.EraseSection('RecentFiles');
   for I := 0 to RecentFiles.Count-1 do
    theIni.WriteString('RecentFiles', 'File'+IntToStr(i+1), RecentFiles[i]);
   theIni.UpdateFile;
  finally
   theIni.Free;
  end;
end;

// Charge et renvoi  de la prochaine astuce (Tips)
function TDMFonction.ChargerAstuce: string;
var
 TheStringList : TStringList;
begin
  ChargerAstuce := EmptyStr;
  theStringList := TStringList.Create;
  try
   //Lire les astuces ici
   theStringList.LoadFromFile(Chemin+ASTUCE);
    if(TheStringList.Text = EmptyStr)then
     ShowTipsOnStartup := False
    else
    begin
     inc(LastTipShown);
     if( LastTipShown > TheStringList.Count -1 )then
      LastTipShown := 0;
     ChargerAstuce:= TheStringList[LastTipShown];
    end
  finally
    TheStringList.Free;
  end;
end;

// Ajout d'un item de menu  la liste des fichers recents
procedure TDMFonction.AddFileToRecentFilesList(fname: string);
var theMenuItem: TMenuItem;
  oldPos: integer;
begin
  if(RecentFiles.IndexOf(fname)=-1)and(FileExists(fname))then
  begin
    RecentFiles.Insert(0, fname);

    theMenuItem:=TMenuItem.Create(FormMain);
    inc(RecentFilesMICounter);
    theMenuItem.Name:='OpenRecent'+IntToStr(RecentFilesMICounter+1)+'MI';
    theMenuItem.Caption:=ExtractFileName(fname);
    theMenuItem.OnClick:=OpenRecentFile;

    FormMain.OpenRecentMI.Insert(0, theMenuItem);

    if(RecentFiles.Count>10)then
    begin
      RecentFiles.Delete(10);
      theMenuItem:=FormMain.OpenRecentMI[10];
      FormMain.OpenRecentMI.Delete(10);
      theMenuItem.Free;
    end;
  end
  else if(RecentFiles.IndexOf(fname)>0)and(FileExists(fname))then
  begin
    oldPos:=RecentFiles.IndexOf(fname);
    RecentFiles.Delete(oldPos);
    RecentFiles.Insert(0, fname);

    theMenuItem:=FormMain.OpenRecentMI[oldPos];
    FormMain.OpenRecentMI.Delete(oldPos);
    FormMain.OpenRecentMI.Insert(0, theMenuItem);
  end;
end;

// compte le nombre de fichier recent existant
function TDMFonction.GetRecentFileCount: integer;
begin
  GetRecentFileCount:=RecentFiles.Count;
end;

// Renvoi le nom du fichier pass en ID
function TDMFonction.GetRecentFileName(id: integer): string;
begin
 GetRecentFileName:=RecentFiles[id];
end;

// Ouvre le dernier fichier recent
procedure TDMFonction.OpenRecentFile(Sender: TObject);
begin
 FormMain.OpenFile(GetRecentFileName(FormMain.OpenRecentMI.IndexOf(TMenuItem(Sender))));
end;

// Sauve la position de la fenetre passe en parametre dans le fichier ini
procedure TDMFonction.SaveWinPos(win: TForm; DoSize: Boolean);
var
 WinName: string;
 TheIni: TIniFile;
 P: TPoint;
begin
  If not SavePosWin then
   exit;
  WinName := win.name;
  P:=win.ClientToScreen(Point(0, 0));

  try
   theIni:=TIniFile.Create(SettingsPath+SETTING);
   if win.WindowState =wsMaximized then
      theIni.WriteInteger('WindowPositions', WinName+'State', 1)
    else
    begin
      theIni.WriteInteger('WindowPositions', WinName+'State', 0);
      if(P.X>0)then
        theIni.WriteInteger('WindowPositions', WinName+'Left', P.X)
      else
        theIni.WriteInteger('WindowPositions', WinName+'Left', 15);

      if(P.Y>0)then
        theIni.WriteInteger('WindowPositions', WinName+'Top', P.Y)
      else
        theIni.WriteInteger('WindowPositions', WinName+'Top', 15);

      if(DoSize)then
      begin
        theIni.WriteInteger('WindowPositions', WinName+'Width', win.Width);

        theIni.WriteInteger('WindowPositions', WinName+'Height', win.Height);
      end;
    end;

    theIni.UpdateFile;
  finally
    theIni.Free;
  end;
end;

// Restaure la position de la fenetre passe en parametre depuis le fichier ini
procedure TDMFonction.RestoreWinPos(win: TForm; DoSize: Boolean);
var
  TheIni   : TIniFile;
  WinName  : string;
  P        : TPoint;
  WinPos   : TPoint;
begin
  If not SavePosWin then
   exit;
  WinName := win.name;
  TheIni  := TIniFile.Create(SettingsPath+SETTING);
  try
    try
      WinPos.X:=theIni.ReadInteger('WindowPositions', WinName+'Left', 80);
      WinPos.Y:=theIni.ReadInteger('WindowPositions', WinName+'Top', 140);
      if(WinPos.X>Screen.Width)then
        WinPos.X:=Screen.Width-50;
      if(WinPos.Y>Screen.Height)then
        WinPos.Y:=Screen.Height-50;

      win.Left:=WinPos.X-WinPosCorrection[Ord(win.BorderStyle)].X;
      win.Top:=WinPos.Y-WinPosCorrection[Ord(win.BorderStyle)].Y;

      P:=win.ClientToScreen(Point(0, 0));
      if(P.X<>WinPos.X)or(P.Y<>WinPos.Y)then
      begin
        WinPosCorrection[Ord(win.BorderStyle)].X:=P.X-WinPos.X;
        WinPosCorrection[Ord(win.BorderStyle)].Y:=P.Y-WinPos.Y;

        win.Left:=WinPos.X-WinPosCorrection[Ord(win.BorderStyle)].X;
        win.Top:=WinPos.Y-WinPosCorrection[Ord(win.BorderStyle)].Y;
      end;

      if(win.Top<0)then
        win.Top:=0;
      if(DoSize)then
      begin
        win.Width:=
          theIni.ReadInteger('WindowPositions', WinName+'Width', 140);
        win.Height:=
          theIni.ReadInteger('WindowPositions', WinName+'Height', 140);
        if(theIni.ReadInteger('WindowPositions', WinName+'State', 0)=1)then
          win.WindowState:=wsMaximized;
      end;
    except
      win.Left:=((Application.MainForm.Left+Application.MainForm.Width)-win.Width) div 2-40;
      win.Top:=((Application.MainForm.Top+Application.MainForm.Height)-win.Height) div 2;
    end;
  finally
    TheIni.Free;
  end;
end;

// Incremente un compteur pour les fichiers sansNom
function TDMFonction.GetNextNonameNumber: String;
begin
  inc(NonameCounter);
  GetNextNonameNumber:=IntToStr(NonameCounter);
end;

// Renvoi J H M S en fonction d'un nombre de secondes passs en parametres
Function  TDMFonction.SecondeToTemps(lesSecondes : Integer):String;
Var
  heure, minute,seconde : Word;
  NbDeSeconde           : Integer;
Begin
 NbDeSeconde   := lesSecondes;
 heure         := (NbDeSeconde Div 3600);
 NbDeSeconde   := NbDeSeconde - (3600 * heure);
 minute        := (NbDeSeconde Div 60);
 NbDeSeconde   := NbDeSeconde - (60 * minute);
 seconde       := NbDeSeconde ;
 result        := StringOfChar('0',2-Length(intToStr(heure)))+ intToStr(heure)+':';
 result        := result + StringOfChar('0',2-Length(intToStr(minute)))+ intToStr(minute)+':';
 result        := result + StringOfChar('0',2-Length(intToStr(seconde)))+ intToStr(seconde);
End;

// generer un nom aleatoirement
// en gros un mini GUID sur lg caractere
// utilis pour la propriet Name d'un composant cre dynamiquement

function TDMFonction.NomAleat(Lg : Integer): String;
var
 I : Integer;
begin
 result := EmptyStr;
 for I := 0 to lg - 1 do
  Result := Result + Chr(Aleatoire(65,90));
end;


// renvoi un nombre aleatoire compris entre
// Num1 et Num2     exemple : Aleatoire(65,91)
function TDMFonction.Aleatoire(Num1,Num2:integer):integer;
var
 Diff: integer;
begin
 inc(Num2);
 Diff:=Num2-Num1;
 Result := Random(Diff)+ Num1;
end;

// Renvoi True sous Vista ou suprieur sinon False
function TDMFonction.ThemeAndVista(): Boolean;
begin
 Result :=  IsThemeActive;
 If SysUtils.Win32MajorVersion < 6 then // avant VISTA
  Result := False;
end;
end.
