unit UMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnCtrls, ToolWin, ActnMan, ActnMenus, StdActns, ActnList,
  XPStyleActnCtrls, StdCtrls, ImgList, ComCtrls, Menus,inifiles, ExtActns,
  ExtCtrls,UDmFonction, XPMan, ActnColorMaps,Jpeg;

type
  TFormMain = class(TForm)
    ActionManager1: TActionManager;
    ImageListN: TImageList;
    ImageListD: TImageList;
    ToolBarMain: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ImageListPt: TImageList;
    ActionNouveau: TAction;
    EditCopier: TEditCopy;
    EditColler: TEditPaste;
    ActionOuvrir: TAction;
    ActionEnregistrer: TAction;
    ActionEnregSous: TAction;
    ActionImprime: TAction;
    ActionQuitter: TAction;
    ActionAide: TAction;
    ActionAPropos: TAction;
    ActionConfig: TAction;
    MainMenu: TMainMenu;
    Menu_Fichier: TMenuItem;
    Nouveau1: TMenuItem;
    Ouvrir1: TMenuItem;
    Enregistrer1: TMenuItem;
    EnregistrerSous1: TMenuItem;
    Configurer1: TMenuItem;
    Quitter1: TMenuItem;
    Menu_Edition: TMenuItem;
    Dupliquer: TMenuItem;
    N3: TMenuItem;
    Menu_aide: TMenuItem;
    Aideduprogramme1: TMenuItem;
    AProposde1: TMenuItem;
    StatusBar: TStatusBar;
    Astuce: TMenuItem;
    ActionAstuce: TAction;
    N4: TMenuItem;
    BrowseURL1: TBrowseURL;
    Menu_BarreOutils: TMenuItem;
    MenuSiteWeb: TMenuItem;
    OpenRecentMI: TMenuItem;
    N6: TMenuItem;
    MenuOutils: TMenuItem;
    ToolButton14: TToolButton;
    XPManifest1: TXPManifest;
    ActionDupliquer: TAction;
    MenuColler: TMenuItem;
    MenuCopier: TMenuItem;
    ActionGrilleToJPG: TAction;
    GrilleversBMP1: TMenuItem;
    Imprimer1: TMenuItem;
    N12: TMenuItem;
    SaveDialogBmp: TSaveDialog;
    ImageJPG: TImage;
    TaskDialogNewGrid: TTaskDialog;
    ToolButton3: TToolButton;
    TheOpenDialog: TOpenDialog;
    PageControlFrame: TPageControl;
    procedure ActionNouveauExecute(Sender: TObject);
    procedure ActionOuvrirExecute(Sender: TObject);
    procedure ActionEnregistrerExecute(Sender: TObject);
    procedure ActionImprimeExecute(Sender: TObject);
    procedure ActionQuitterExecute(Sender: TObject);
    procedure ActionAideExecute(Sender: TObject);
    procedure ActionConfigExecute(Sender: TObject);
    procedure ActionEnregSousExecute(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActionAProposExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActionAstuceExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Menu_BarreOutilsClick(Sender: TObject);
    procedure OpenFile(fname: string);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ShowHint(Sender : tObject);
    procedure MajAction(Suppr : Boolean = False);
    procedure ActionDupliquerExecute(Sender: TObject);
    procedure EditCopierExecute(Sender: TObject);
    procedure EditCollerExecute(Sender: TObject);
    procedure ActionGrilleToJPGExecute(Sender: TObject);
  private
    { Dclarations prives }

  public
    { Dclarations publiques }
    RecorderTMP         : array [0..1000] of TActionSudoku; // prevoyons large
    PositionRecorderTMP : Integer;
    DureePartieTmp      : Integer;

   procedure SetStatusCaption(s: string);

  end;

var
  FormMain: TFormMain;

implementation

uses USplash, Tips, UConfig, UFrame, UcreerGrille;

{$R *.dfm}



//******************************************
// Cration d'une nouvelle fenetre fille
//******************************************
procedure TFormMain.ActionNouveauExecute(Sender: TObject);
var
  Retour       : TmodalResult;
  ChaineSudoku : String[81];
  NewTabs      : TTabSheet;
  NewFrame     : TFramefille;
begin

 // demande du type de grille  Vierge ou jouable
 TaskDialogNewGrid.ModalResult := 0;
 if DMFonction.ThemeAndVista() then
 begin
  // sous vista
  TaskDialogNewGrid.Execute;
  If TaskDialogNewGrid.ModalResult = mrCancel then
  begin
   Exit;
  end;
 end
 else
 begin
  // avant vista
  Retour := MessageDlg(Message013,mtConfirmation,[MbYes,MbNo,mbCancel],0);
  if Retour = mrCancel then
  begin
   Exit;
  end;
 end;

 // creation d'un onglet et de sa frame
  NewTabs := TTabSheet.Create(Self);
  with NewTabs do
  begin
   Name                   := DMFonction.NomAleat(6); // un nom aleatoire
   Caption                := NONAME+Chr(127)+Chr(127)+DMFonction.GetNextNonameNumber+SPACES; //Initialise le nom
   Parent                 := Self;
   PageControl            := PageControlFrame;
   NewFrame               := TFramefille.Create(NewTabs);
   NewFrame.Parent        := NewTabs;
   NewFrame.Align         := alClient;
   NewFrame.Name          := Name;
   NewFrame.CheminCourant := EmptyStr;
   NewFrame.AvoirNom      := False;
   NewFrame.CreerPlateau;
  end;
  // si grille genre
  if (TaskDialogNewGrid.ModalResult = 101) Or (Retour = MrYes) then
  begin
   ChaineSudoku := Generer;
   NewFrame.ChaineToGrille(ChaineSudoku);
   NewFrame.BtJouerClick(Self);
  end;


 PageControlFrame.ActivePageIndex := NewTabs.PageIndex;  // activer l'onglet
 MajAction; // mise  jour des actionList en fonction du contexte

end;

//******************************************
// Selection et validation du fichier a ouvrir
//******************************************
procedure TFormMain.ActionOuvrirExecute(Sender: TObject);
begin
 // pr selection du bon rpertoire
 if(DirectoryExists(DMFonction.RecentOpenFileDir))then
  theOpenDialog.InitialDir := DMFonction.RecentOpenFileDir
 else
  theOpenDialog.InitialDir := EmptyStr;

 if(theOpenDialog.Execute)then // si Ok selectionn
 begin
  OpenFile(theOpenDialog.Filename); // ouverture proprement dite
  DMFonction.RecentOpenFileDir := ExtractFilePath(theOpenDialog.Filename); // recup du chemin pour la prochaine fois
 end;
end;

//****************************************************
// Verif si fichier existe, maj des menus recents et
// fenetres appel de LoadFromFile pour le fichier
// dans la frame fille
//****************************************************
procedure TFormMain.OpenFile(fname: string);
var
 NewTabs      : TTabSheet;
 NewFrame     : TFramefille;
begin
 // en cas de problme
 if(Not(FileExists(fname)))then
  raise EInOutError.Create(Message005+#13#10+fname);

 NewTabs := TTabSheet.Create(Self);
 with NewTabs do
 begin
  Name               := DMFonction.NomAleat(6);
  Parent             := Self;
  PageControl     := PageControlFrame;
  Caption            :=   Copy(ExtractFileName(fname), 1, Length(ExtractFileName(fname))-Length(ExtractFileExt(fname)))+SPACES;
  NewFrame           := TFramefille.Create(NewTabs);
  NewFrame.Name      := Name;
  NewFrame.Parent    := NewTabs;
  NewFrame.Align     := alClient;
  NewFrame.CreerPlateau;
  NewFrame.avoirnom := True;
  NewFrame.CheminCourant := fname;

  // fichier Natif SDT
  if LowerCase(ExtractFileExt(fname)) = '.'+LowerCase(EXTSDT) then
   NewFrame.LoadFromFile;

  // fichier texte
  if LowerCase(ExtractFileExt(fname)) = '.'+LowerCase(EXTTXT) then
  begin
   NewFrame.LoadFromFileTexte(fname);
   NewFrame.AvoirNom  := False;
  end;
 end;

 DMFonction.AddFileToRecentFilesList(fname); //Ajouter  la liste des fichiers recents
 MajAction; // mettre a jour les ActionList en fonction du contexte
 PageControlFrame.ActivePageIndex := NewTabs.PageIndex; // activer le bon Onglet
end;


//****************************************************
// Enregistrer le fichier
//****************************************************
procedure TFormMain.ActionEnregistrerExecute(Sender: TObject);
Var
 TheFrame : TComponent;
begin
 TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
 if not (TheFrame as TFramefille).AvoirNom then  // appel de enregistrer sous car pas encore de nom pour le fichier de cette fenetre
  ActionEnregSousExecute(self)
  else
  (TheFrame as TFramefille).SaveToFile;  // appel de SaveToFile de cette fentre fille
end;


//****************************************************
// Imprimer
//****************************************************
procedure TFormMain.ActionImprimeExecute(Sender: TObject);
Var
 TheFrame : TComponent;
begin
 TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
 (TheFrame as TFramefille).Imprimer;
end;

//****************************************************
// Action Quitter Un simple Close
// Attention appel intermediaire a onCloseQuery
//****************************************************
procedure TFormMain.ActionQuitterExecute(Sender: TObject);
begin
 close;
end;

//**********************************
// voulez vous quitter ?
//**********************************
procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 If DmFonction.QuitConfirm then
  If MessageDLG('Voulez-vous vraiment quitter ?',mtConfirmation,[mbYes,MbNo],0) = MrNo then
   Action := CaNone;
end;

//*********************************************************************************
// avant d'appeler le Close, on verifie les fenetres modifies devant tre sauves
//*********************************************************************************
procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
 i : Integer;
 TheFrame : TComponent;
begin
 For i := 0 to PageControlFrame.PageCount -1 do
 begin
  TheFrame := PageControlFrame.Pages[i].FindComponent(PageControlFrame.Pages[i].Name);
  IF not (TheFrame as TFramefille).fermer() then
  begin
   CanClose := False;
   exit;
  end;
 end;
end;

//*********************************************************************************
// Appel de l'aide on appel un URI
//*********************************************************************************
procedure TFormMain.ActionAideExecute(Sender: TObject);
begin
 DMFonction.AppelBrowser(DMFonction.Chemin+'SudokuTrainerAide.html') ;
end;


//**********************************************************************
// Gestion des parametres globaux de l'application
// Placez ici les parametres propes a l'application
//**********************************************************************
procedure TFormMain.ActionConfigExecute(Sender: TObject);
Var
 FrmConfig : TFrmConfig;
 TheFrame  : TComponent;
begin

 FrmConfig:=TFrmConfig.Create(self); // constructeur
 // charger l'ecran avec les valeurs
 FrmConfig.LbShowTipsOnStartup.Checked := DMFonction.ShowTipsOnStartup;
 FrmConfig.LbSavePosWin.Checked        := DMFonction.SavePosWin;
 FrmConfig.CbQuitConfirm.checked       := DMFonction.QuitConfirm;
 FrmConfig.UpDown1.Position            := DMFonction.TimeSplash;
 FrmConfig.CBReopenLastFile.Checked    := DMFonction.ReopenLastFile;
 FrmConfig.ShapeChiffre.Brush.Color    := DMFonction.CouleurChiffre;
 FrmConfig.ShapeDevoile.Brush.Color    := DMFonction.CouleurDevoile;
 FrmConfig.ShapeCandidat.Brush.Color   := DMFonction.CouleurCandidat;
 FrmConfig.ShapeJouable.Brush.Color    := DMFonction.CouleurJouable;
 FrmConfig.ShapeReference.Brush.Color  := DMFonction.CouleurReference;
 FrmConfig.CBCandidatsOnOff.Checked    := DMFonction.candidatsOnOff;
 FrmConfig.CBProtectionOnOFF.Checked   := DMFonction.ProtectionOnOff;


 If FrmConfig.ShowModal = MrOk then  //Affichage
 Begin
  // sauvegarder les valeurs
  DMFonction.ShowTipsOnStartup := FrmConfig.LbShowTipsOnStartup.Checked;
  DMFonction.SavePosWin        := FrmConfig.LbSavePosWin.Checked;
  DMFonction.TimeSplash        := FrmConfig.UpDown1.Position;
  DMFonction.QuitConfirm       := FrmConfig.CbquitConfirm.checked;
  DMFonction.ReopenLastFile    := FrmConfig.CBReopenLastFile.Checked;
  DMFonction.CouleurChiffre    := FrmConfig.ShapeChiffre.Brush.Color;
  DMFonction.CouleurDevoile    := FrmConfig.ShapeDevoile.Brush.Color;
  DMFonction.CouleurCandidat   := FrmConfig.ShapeCandidat.Brush.Color;
  DMFonction.CouleurJouable    := FrmConfig.ShapeJouable.Brush.Color;
  DMFonction.CouleurReference  := FrmConfig.ShapeReference.Brush.Color;
  DMFonction.CandidatsOnOff    := FrmConfig.CBCandidatsOnOff.Checked;
  DMFonction.ProtectionOnOff   := FrmConfig.CBProtectionOnOFF.Checked;

  If PageControlFrame.PageCount > 0 then
  begin
   TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
   (TheFrame as TFramefille).MettreCouleurCandidat;
   (TheFrame as TFramefille).ToutRejouer;
  end;
 end;
 FrmConfig.Free; // liberation
end;


//*****************************************************************
// si le fichier n'a pas encore de nom
//*****************************************************************
procedure TFormMain.ActionEnregSousExecute(Sender: TObject);
Var
 TheFrame            : TComponent;
 theSaveDialog       : TSaveDialog;
 RecentSaveFileAsDir : string;
 theFileName         : string;
 Msg                 : String;
begin
 theSaveDialog:=TSaveDialog.Create(nil); // construction d'une boite SAVE
 try
  // preparation de la boite
  theSaveDialog.Title       := Message006;
  theSaveDialog.DefaultExt  := EXTSDT;
  RecentSaveFileAsDir       := DMFonction.LoadValueFromSettingsIniFile('RecentDirectories', 'RecentSaveFileAsDir', DMFonction.SettingsPath);
  if(Not(DirectoryExists(RecentSaveFileAsDir)))then
   RecentSaveFileAsDir      := DMFonction.SettingsPath;
  theSaveDialog.InitialDir  := RecentSaveFileAsDir;
  theSaveDialog.Filter      := Message007 + ' (*.'+EXTSDT+')|*.'+EXTSDT;
  if(theSaveDialog.Execute)then
  begin
   // si ok
   theFileName:=theSaveDialog.Filename;
   if(FileExists(theFileName))then
   begin
    Msg := format('Le fichier %s existe dj.#13#10 Voulez-vous  l''craser',[ExtractFileName(theSaveDialog.Filename)] );
    if Messagedlg(Msg,mtInformation,[mbYes, mbNo], 0)=mrNo then
     Exit;
   end;
   TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
   (TheFrame as TFramefille).CheminCourant := TheFileName;
   (TheFrame as TFramefille).AvoirNom := true;
   PageControlFrame.Pages[PageControlFrame.ActivePageIndex].Caption := Copy(ExtractFileName(TheFileName), 1, Length(ExtractFileName(TheFileName))-Length(ExtractFileExt(TheFileName)))+SPACES;
   (TheFrame as TFramefille).SaveToFile;
   //Ajout  la liste des fichiers recents
   RecentSaveFileAsDir:=ExtractFilePath(theSaveDialog.FileName);
   DMFonction.SaveValueInSettingsIniFile('RecentDirectories', 'RecentSaveFileAsDir', RecentSaveFileAsDir);
  end;
 finally
  theSaveDialog.Free;
 end;
end;


//*********************************
// appel de la Splash Form ( A propos sans Timer , le timer est actif uniquement au lancement)
//*********************************
procedure TFormMain.ActionAProposExecute(Sender: TObject);
var
 FormSplash : TFormSplash;
begin
 try
  FormSplash:=TFormSplash.Create(self);
  FormSplash.TimerSplash.Enabled := False;
  FormSplash.ShowModal;
 finally
  FormSplash.Free;
 End;
End;



//****************************************************************
// construction de la fentre principale
//****************************************************************
procedure TFormMain.FormCreate(Sender: TObject);
var
 theIni       : TIniFile;
 theStringList: TStringList;
 I            : Integer;
begin
 try
  theIni        := TIniFile.Create(DMFonction.SettingsPath+SETTING);
  theStringList := TStringList.Create;

  //construction d'une liste des fichies recents
  theIni.ReadSectionValues('RecentFiles', theStringList);
  for I := theStringList.Count-1 downto 0 do
   DMFonction.AddFileToRecentFilesList(Copy(theStringList[i], Pos('=', theStringList[i])+1, Length(theStringList[i])));

 finally
  Application.OnHint := ShowHint; // renvoi du onhint vers une routine personnalise
  if(DMFonction.ShowTipsOnStartup)then // appel de tips (astuce) si c'est voulu
   ActionAstuceExecute(Self);
  theStringList.Free;
  theIni.Free;
 end;
end;

//************************************
// Les hints vers la barre d'tat
//************************************
procedure TFormMain.ShowHint(Sender : tObject);
begin
 StatusBar.Panels[0].Text := '  '+ GetLongHint(Application.Hint);
 StatusBar.Refresh;
end;
//************************************
// Les information diverses vers la barre d'tat
//************************************
procedure TFormMain.SetStatusCaption(s: string);
begin
  StatusBar.Panels[0].Text := '  '+ s;
  StatusBar.Refresh;
end;

// Appel de l'ecran TIPS avec l'astuce nouvelle
procedure TFormMain.ActionAstuceExecute(Sender: TObject);
Var
 TexteAstuce : String;
begin
 // appel de l'astuce
 TexteAstuce := DMFonction.ChargerAstuce;
 if (TexteAstuce <> EmptyStr) then
 begin
  try
   TipsForm:=TTipsForm.Create(self);
   TipsForm.TipMemo.Text:=TexteAstuce;
   TipsForm.DisableTipsOnStartupCBox.Checked := not DMFonction.ShowTipsOnStartup;
   TipsForm.Show;
  except
   TipsForm.Free;
  end;
 end;
end;


//**********************************************************
//  A l'affichage on confectionne un contexte propre
//**********************************************************
procedure TFormMain.FormShow(Sender: TObject);
begin
 Menu_BarreOutils.Checked :=  DMFonction.Toolbar_Visible; // la barre d'outils visible ou non
 ToolBarMain.Visible       := DMFonction.Toolbar_Visible;
 if(DMFonction.ReopenLastFile)and(DMFonction.GetRecentFileCount>0)then
  OpenFile(DMFonction.GetRecentFileName(0));
 MajAction;
end;




//*****************************************
// ON/OFF de la barre d'outils
//*****************************************
procedure TFormMain.Menu_BarreOutilsClick(Sender: TObject);
begin
  Menu_BarreOutils.Checked   := Not(Menu_BarreOutils.Checked);
  DMFonction.Toolbar_Visible := Menu_BarreOutils.Checked;
  ToolBarMain.Visible        := Menu_BarreOutils.Checked;
end;

//************************************************************
// Active/desactive les ActionsList et tmenu  en fonction du contexte
//************************************************************
procedure TFormMain.MajAction(Suppr : Boolean = False);
var
 Action : Boolean;
begin
 if Suppr then
  Action := PageControlFrame.PageCount > 1
 Else
  Action := PageControlFrame.PageCount > 0;

 ActionEnregistrer.Enabled       := Action;
 ActionEnregSous.Enabled         := Action;
 ActionImprime.Enabled           := Action;
 ActionDupliquer.Enabled         := Action;
 MenuCopier.Enabled              := Action;
 MenuColler.Enabled              := Action;
 ActionGrilleToJPG.enabled       := Action;

end;


//*****************************************
// Duplique  du Sudoku en cours dans
// une nouvelle fentre
//*****************************************
procedure TFormMain.ActionDupliquerExecute(Sender: TObject);
Var
  TheFrame : TComponent;
  NewTabs  : TTabSheet;
  NewFrame : TFramefille;
  I        : Integer;
begin
  TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
  For i := 0 to (TheFrame as TFramefille).PositionRecorder do
   RecorderTMP[i] := (TheFrame as TFramefille).Recorder[I];
  PositionRecorderTMP := i;
  DureePartieTMP := (TheFrame as TFramefille).DureePartie;
  //creation d'un nouvel onglet
 NewTabs := TTabSheet.Create(Self);
 with NewTabs do
 begin
  Name     := DMFonction.NomAleat(6);
  Caption  := NONAME+' '+DMFonction.GetNextNonameNumber+SPACES; //Initialise le nom
  Parent   := Self;
  PageControl := PageControlFrame;
  NewFrame := TFramefille.Create(NewTabs);
  NewFrame.Parent    := NewTabs;
  NewFrame.Align     := alClient;
  NewFrame.Name      := Name;
  NewFrame.CheminCourant := EmptyStr;
  NewFrame.AvoirNom  := False;
  NewFrame.CreerPlateau;
 end;

  // le chargement du recorderTMP se fait dans la fentre fille au chargement
end;


//*****************************************
// Copie le Sudoku dans le presse papier de Windows
//*****************************************
procedure TFormMain.EditCopierExecute(Sender: TObject);
Var
 TheFrame : TComponent;
begin
 TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
    (TheFrame as TFramefille).GrilleToPP;
end;

//*****************************************
// Rcupere le sudoku du PP de Windows
// et le pose dans la grille(vide) courante
//*****************************************
procedure TFormMain.EditCollerExecute(Sender: TObject);
Var
 TheFrame : TComponent;
begin
 TheFrame := PageControlFrame.ActivePage.FindComponent(PageControlFrame.ActivePage.Name);
    (TheFrame as TFramefille).PPToGrille;
end;

//*****************************************
// Generer un fichier JPEG sur le dique depuis la grille courante
//*****************************************
procedure TFormMain.ActionGrilleToJPGExecute(Sender: TObject);
var
  jp          : TJPEGImage;
  theFileName : String;
  Msg         : String;
begin
 IF SaveDialogBMP.Execute then
 Begin
  theFileName:=SaveDialogBMP.Filename;
  if(FileExists(theFileName))then
  begin
   Msg := Format(Message014 ,[ExtractFileName(theFileName)]);
   if MessageDlg(msg ,mtInformation,[mbYes, mbNo], 0)= mrNo then
    Exit;
  end;
  update;
  ImageJPG.Canvas.CopyRect(Rect(0,0,445,465), PageControlFrame.canvas,Rect(20,45,465,520));
  jp := TJPEGImage.Create;
  try
    with jp do
    begin
      Assign(ImageJPG.Picture.Bitmap);
      SaveToFile(SaveDialogBMP.FileName);
    end;
  finally
    jp.Free;
  end;
 end;
end;




end.
