unit USplash;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls,ShellApi,inifiles;

type
  TFormSplash = class(TForm)
    TimerSplash: TTimer;
    InfoLbl1: TLabel;
    InfoLbl2: TLabel;
    VersionLbl: TLabel;
    LblTitreEmail: TLabel;
    LblEmail: TLabel;
    LblSite: TLabel;
    LblTitreSite: TLabel;
    Label1: TLabel;
    procedure TimerSplashTimer(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure LblEmailClick(Sender: TObject);
    procedure LblSiteClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure LblEmailMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseEnter(Sender: TObject);
  private
    { Dclarations prives }
   SplashImg : TBitmap ;
  public
    { Dclarations publiques }
  end;

var
 FormSplash: TFormSplash;

implementation

uses UDmFonction;

{$R *.dfm}

//*****************************
// lors du onTimer on ferme
//*****************************
procedure TFormSplash.TimerSplashTimer(Sender: TObject);
begin
 TimerSplash.Enabled:=False;
 Close;
End;

//*****************************
// lors d'un mousUop on close
//*****************************
procedure TFormSplash.FormMouseEnter(Sender: TObject);
begin
 Cursor := crDefault;
end;

procedure TFormSplash.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 ModalResult:=mrAbort;
end;

//*****************************
// lors du Close on libere
//*****************************
procedure TFormSplash.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action:=caFree;
end;

//*****************************
// lors du Destroy on libere
//*****************************
procedure TFormSplash.FormDestroy(Sender: TObject);
begin
 SplashImg.Free;
end;

procedure TFormSplash.FormKeyPress(Sender: TObject; var Key: Char);
begin
 Close;
end;

//*****************************
// Chargement des infos
//*****************************
procedure TFormSplash.FormCreate(Sender: TObject);
var
 theIni: TIniFile;
 Delay : Integer;
begin
 try
  SplashImg := TBitmap.Create;
  SplashImg.Mask(clwhite);
  if FileExists(ExtractFilePath(Application.ExeName)+'SplashSudokuTrainer.bmp') then
   SplashImg.LoadFromFile(ExtractFilePath(Application.ExeName)+'SplashSudokuTrainer.bmp'); // l'image
  theIni:=TIniFile.Create(DMFonction.SettingsPath+SETTING);
  Delay := theIni.ReadInteger('GeneralSettings', 'TimeSplash',3000); // le delai d'affichage
  If Delay < 1000 then
   delay := Delay * 1000;
 finally
  theIni.Free;
  TimerSplash.Enabled  := False;
  TimerSplash.Interval := Delay;
  TimerSplash.Enabled  := true;  // GO !
  end;
end;


//***********************************
// Dessin de l'image sur la form
//***********************************
procedure TFormSplash.FormPaint(Sender: TObject);
begin
  if(Assigned(SplashImg))then
  begin
   Canvas.Draw(0, 0, SplashImg);
   width  := SplashImg.Width;
   height := SplashImg.height;
  end;
  VersionLbl.Caption :=  'Version : ' + DmFonction.RenvoiVersion();
end;

//***********************************
// si le caption du label est une @ mail
// au moment du clic l'outil de messagerie
// de windows et lanc
//***********************************
procedure TFormSplash.LblEmailClick(Sender: TObject);
Var
 Buffer : array[0..255] of Char;
begin
 ShellExecute(ValidParentForm(Self).Handle, 'open',
  StrPCopy(Buffer,'mailto:'+(Sender as TLabel).caption), nil, nil, SW_SHOW);
end;


procedure TFormSplash.LblEmailMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Cursor := crHandPoint;
end;

//***********************************
// si le caption du label est une url/Uri
// au moment du clic le navigateur est
//appel
//***********************************
procedure TFormSplash.LblSiteClick(Sender: TObject);
begin
 DMFonction.AppelBrowser((Sender as TLabel).caption) ;
End;

//********************************************************
// positionnement au centre quand l'on connait la taille
// de la l'image
//********************************************************
end.


